import { Component, OnInit } from '@angular/core';

import { Mieter } from '../mieter';
import { MieterService } from '../mieter.service';
import { MessageService } from '../message.service';
import { ZahlungForderungService} from '../zahlung-forderung.service'

import { Saldo } from '../zahlung-forderung'


@Component({
  selector: 'app-mieters',
  templateUrl: './mieters.component.html',
  styleUrls: ['./mieters.component.css']
})
export class MietersComponent implements OnInit {

  mieters: Mieter[]
  year: string
  selectedMieter : Mieter

  constructor(
    private mieterService: MieterService, 
    private zahlungForderungService: ZahlungForderungService,
    private messageService: MessageService) {      
  }

  async getMieters() {
    try {
      this.mieters = await this.mieterService.getMieters();      
    } catch (err) {
      this.messageService.add(JSON.stringify(err, undefined, 4))
    }
  }

  async loadSaldos() {
    try {
      this.mieters.forEach(async (m:Mieter) => {
        let saldo: Saldo = await this.zahlungForderungService.getSaldoByMieterAndYear(m.id, +this.year)
        m.saldo = saldo.saldo
      })
    } catch (err) {
      this.messageService.add(JSON.stringify(err, undefined, 4))
    }
  }

  ngOnInit(): void {
    this.year = new Date().getFullYear().toString()
    this.getMieters();
    this.loadSaldos();
  }
}
